//
//  Brahe
//  A heterogenous library of mathematical and scientific functions
//
//  trig.h
//
//  Copyright 2006, 2007 Scott Robert Ladd
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the
//      Free Software Foundation, Inc.
//      59 Temple Place - Suite 330
//      Boston, MA 02111-1307, USA.
//
//  For more information on this software package, please visit
//  Scott's web site, Coyote Gulch Productions, at:
//
//      http://www.coyotegulch.com
//
//  Closed-source licenses are available from the author at reasonable
//  prices.
//  

#include "mathtools.h"

// hyperbolic arcsine
double brahe_asinh(const double x)
{
    return log(x + sqrt(x * x + 1.0));
}

//  hyperbolic arccosine 
double brahe_acosh(const double x)
{
    return log(x + sqrt(x * x - 1.0));
}

//  hyperbolic arctangent 
double brahe_atanh(const double x)
{
    return log((1.0 + x) / (1.0 - x)) / 2.0;
}
